searchNodes=[{"doc":"A module to create JSON-RPC clients and handle JSON-RPC requests. For more information to JSON-RPC 2.0 see the specification . JsonRPC comes without any code to sending the generated JSON-RPCs. For the transport the behaviour JsonRPC.Transport has to be used. JsonRPC uses jason per default. To customize the JSON library, including the following in your config: config :json_rpc , parser : :poison Client A client can be written by using JsonRPC . defmodule Example.Client do use JsonRPC , transport : Example.Transport rpc add ( a , b ) rpc msg ( text ) , notification : true rpc message ( text ) , notification : true , delegate : &quot;msg&quot; rpc params ( map ) , params : :by_name end The module Example.Client contains now the functions add/2 , msg/1 , message/1 and params/1 . When one of this function will be called a JSON-RPC will be generated and Example.Transport.send_rpc/2 will be called. The first argument of Transport.send_rpc/2 is the encoded JSON-RPC and the second argument are the options given to JsonRPC . See Transport.send_rpc for more information. See rpc/2 for more information about the options. Server A server has to use the function handle_request/2 .","ref":"JsonRPC.html","title":"JsonRPC","type":"module"},{"doc":"Handles the given HandleRequestError . This function generates a JSON-RPC error response for the given error . The optional opts can overwrite the values for :code and :message . Examples iex&gt; defmodule Mod do ...&gt; def carp , do : raise RuntimeError , &quot;no!&quot; ...&gt; end iex&gt; request = %{ id : 3 , jsonrpc : &quot;2.0&quot; , method : &quot;carp&quot; , params : [ ] } iex&gt; try do ...&gt; JsonRPC . handle_request ( request , Mod ) ...&gt; rescue ...&gt; error in JsonRPC.HandleRequestError -&gt; ...&gt; JsonRPC . handle_error ( error ) ...&gt; end %{ id : 3 , error : %{ code : - 32000 , message : &quot;** (RuntimeError) no!&quot; } , jsonrpc : &quot;2.0&quot; }","ref":"JsonRPC.html#handle_error/2","title":"JsonRPC.handle_error/2","type":"function"},{"doc":"Handles the given json request and executes the corresponding function on the given module . The function returns the result of the called function as an JSON-RPC response. If the given request encoded JSON, the result is also encoded JSON, and for a decoded request, a decode response is returned. For a notification (a request without id) the function returns :notification . handle_request/2 catches exceptions raised by the called function and raises a JsonRPC.HandleRequestError . This error could be handled with handle_error/2 . Examples iex&gt; defmodule Math do ...&gt; def add ( a , b ) , do : a + b ...&gt; end iex&gt; request = %{ id : &quot;id-1&quot; , jsonrpc : &quot;2.0&quot; , method : &quot;add&quot; , params : [ 1 , 2 ] } iex&gt; JsonRPC . handle_request ( request , Math ) %{ id : &quot;id-1&quot; , jsonrpc : &quot;2.0&quot; , result : 3 } iex&gt; JsonRPC . handle_request ( Jason . encode! ( request ) , Math ) ~s|{&quot;id&quot;:&quot;id-1&quot;,&quot;jsonrpc&quot;:&quot;2.0&quot;,&quot;result&quot;:3}| iex&gt; request = %{ id : &quot;id-2&quot; , jsonrpc : &quot;2.0&quot; , method : &quot;unknown&quot; , params : [ 1 , 2 ] } iex&gt; JsonRPC . handle_request ( request , Math ) %{ id : &quot;id-2&quot; , error : %{ code : - 32601 , data : %{ method : &quot;unknown&quot; } , message : &quot;Method not found&quot; } , jsonrpc : &quot;2.0&quot; }","ref":"JsonRPC.html#handle_request/2","title":"JsonRPC.handle_request/2","type":"function"},{"doc":"Handles the given json response. The response must contain an id from a previously sent request. This function is usually used in an asynchronous JsonRPC.Transport implementation.","ref":"JsonRPC.html#handle_response/1","title":"JsonRPC.handle_response/1","type":"function"},{"doc":"Defines a RPC with the given name and arguments. Options: :notification - a boolean to mark a RPC as a notification, defaults to false :params - treat arguments either as :by_position or :by_name , defaults to :by_position . The RPC expected a keyword list or a map when params: :by_name is set :delegate - a string that overrides the RPC name","ref":"JsonRPC.html#rpc/2","title":"JsonRPC.rpc/2","type":"macro"},{"doc":"","ref":"JsonRPC.html#t:json/0","title":"JsonRPC.json/0","type":"type"},{"doc":"Representation of a JsonRPC error response. The JsonRPC version is always &quot;2.0&quot; . Examples iex&gt; JsonRPC.ErrorResponse . cast ( id : 42 , error : %{ code : - 32001 , message : &quot;invalid&quot; } ) { :ok , % JsonRPC.ErrorResponse { id : 42 , jsonrpc : &quot;2.0&quot; , error : %{ code : - 32001 , message : &quot;invalid&quot; } } }","ref":"JsonRPC.ErrorResponse.html","title":"JsonRPC.ErrorResponse","type":"module"},{"doc":"Converts the given data according to the defined schema. Returns an :ok tuple with the converted data for valid data , otherwise an :error tuple is returned.","ref":"JsonRPC.ErrorResponse.html#cast/1","title":"JsonRPC.ErrorResponse.cast/1","type":"function"},{"doc":"Converts the given data according to the defined schema. Returns converted data for valid data , otherwise a Xeam.CastError or Xema.ValidationError is raised.","ref":"JsonRPC.ErrorResponse.html#cast!/1","title":"JsonRPC.ErrorResponse.cast!/1","type":"function"},{"doc":"Returns true if the given data valid against the defined schema, otherwise false.","ref":"JsonRPC.ErrorResponse.html#valid?/1","title":"JsonRPC.ErrorResponse.valid?/1","type":"function"},{"doc":"Validates the given data against the defined schema. Returns :ok for valid data, otherwise an :error tuple.","ref":"JsonRPC.ErrorResponse.html#validate/1","title":"JsonRPC.ErrorResponse.validate/1","type":"function"},{"doc":"Validates the given data against the defined schema. Returns :ok for valid data, otherwise a Xema.ValidationError is raised.","ref":"JsonRPC.ErrorResponse.html#validate!/1","title":"JsonRPC.ErrorResponse.validate!/1","type":"function"},{"doc":"Representation of a JsonRPC request. The JsonRPC version is always &quot;2.0&quot; . Examples iex&gt; JsonRPC.Request . cast ( id : &quot;x-1&quot; , method : &quot;say&quot; , params : [ &quot;hello&quot; ] ) { :ok , % JsonRPC.Request { id : &quot;x-1&quot; , jsonrpc : &quot;2.0&quot; , method : &quot;say&quot; , params : [ &quot;hello&quot; ] } } iex&gt; JsonRPC.Request . cast ( method : &quot;beat&quot; ) { :ok , % JsonRPC.Request { id : :notification , jsonrpc : &quot;2.0&quot; , method : &quot;beat&quot; , params : nil } }","ref":"JsonRPC.Request.html","title":"JsonRPC.Request","type":"module"},{"doc":"Converts the given data according to the defined schema. Returns an :ok tuple with the converted data for valid data , otherwise an :error tuple is returned.","ref":"JsonRPC.Request.html#cast/1","title":"JsonRPC.Request.cast/1","type":"function"},{"doc":"Converts the given data according to the defined schema. Returns converted data for valid data , otherwise a Xeam.CastError or Xema.ValidationError is raised.","ref":"JsonRPC.Request.html#cast!/1","title":"JsonRPC.Request.cast!/1","type":"function"},{"doc":"Converts a request to map. The id is omitted when the value is :notification . params is ommitted when it is nil . Examples iex&gt; JsonRPC.Request . to_map ( ...&gt; % JsonRPC.Request { id : &quot;x-1&quot; , jsonrpc : &quot;2.0&quot; , method : &quot;say&quot; , params : [ &quot;hello&quot; ] } ) %{ id : &quot;x-1&quot; , jsonrpc : &quot;2.0&quot; , method : &quot;say&quot; , params : [ &quot;hello&quot; ] } iex&gt; JsonRPC.Request . to_map ( ...&gt; % JsonRPC.Request { id : :notification , jsonrpc : &quot;2.0&quot; , method : &quot;beat&quot; , params : nil } ) %{ jsonrpc : &quot;2.0&quot; , method : &quot;beat&quot; }","ref":"JsonRPC.Request.html#to_map/1","title":"JsonRPC.Request.to_map/1","type":"function"},{"doc":"Returns true if the given data valid against the defined schema, otherwise false.","ref":"JsonRPC.Request.html#valid?/1","title":"JsonRPC.Request.valid?/1","type":"function"},{"doc":"Validates the given data against the defined schema. Returns :ok for valid data, otherwise an :error tuple.","ref":"JsonRPC.Request.html#validate/1","title":"JsonRPC.Request.validate/1","type":"function"},{"doc":"Validates the given data against the defined schema. Returns :ok for valid data, otherwise a Xema.ValidationError is raised.","ref":"JsonRPC.Request.html#validate!/1","title":"JsonRPC.Request.validate!/1","type":"function"},{"doc":"Representation of a JsonRPC response. The JsonRPC version is always &quot;2.0&quot; . Examples iex&gt; JsonRPC.Response . cast ( id : 42 , result : true ) { :ok , % JsonRPC.Response { id : 42 , jsonrpc : &quot;2.0&quot; , result : true } }","ref":"JsonRPC.Response.html","title":"JsonRPC.Response","type":"module"},{"doc":"Converts the given data according to the defined schema. Returns an :ok tuple with the converted data for valid data , otherwise an :error tuple is returned.","ref":"JsonRPC.Response.html#cast/1","title":"JsonRPC.Response.cast/1","type":"function"},{"doc":"Converts the given data according to the defined schema. Returns converted data for valid data , otherwise a Xeam.CastError or Xema.ValidationError is raised.","ref":"JsonRPC.Response.html#cast!/1","title":"JsonRPC.Response.cast!/1","type":"function"},{"doc":"Returns true if the given data valid against the defined schema, otherwise false.","ref":"JsonRPC.Response.html#valid?/1","title":"JsonRPC.Response.valid?/1","type":"function"},{"doc":"Validates the given data against the defined schema. Returns :ok for valid data, otherwise an :error tuple.","ref":"JsonRPC.Response.html#validate/1","title":"JsonRPC.Response.validate/1","type":"function"},{"doc":"Validates the given data against the defined schema. Returns :ok for valid data, otherwise a Xema.ValidationError is raised.","ref":"JsonRPC.Response.html#validate!/1","title":"JsonRPC.Response.validate!/1","type":"function"},{"doc":"An ID generator.","ref":"JsonRPC.ID.html","title":"JsonRPC.ID","type":"behaviour"},{"doc":"Returns an ID.","ref":"JsonRPC.ID.html#c:generate/0","title":"JsonRPC.ID.generate/0","type":"callback"},{"doc":"The transport layer to send a JSON RPC to a server.","ref":"JsonRPC.Transport.html","title":"JsonRPC.Transport","type":"behaviour"},{"doc":"Sends the given json_rpc to a server. This function gets the encoded JSON-RPC and the options of the client as arguments. Returning :ok indicates an asynchronous call or a notification in a synchronous workflow. In an asynchronous workflow the function JsonRPC.handle_response/1 must be called with the response from the server. Returning {:ok, response} runs the request/response loop with the JSON-RPC response in the tuple. Returning {:error, reason} returns an error to the caller of the RPC.","ref":"JsonRPC.Transport.html#c:send_rpc/2","title":"JsonRPC.Transport.send_rpc/2","type":"callback"},{"doc":"An implementation of the JsonRPC.ID behaviour. This module generate a unique ID with System.unique_integer/1 .","ref":"JsonRPC.UID.html","title":"JsonRPC.UID","type":"module"},{"doc":"An implementation of the JsonRPC.ID behaviour. This module generate a version 4 UUID.","ref":"JsonRPC.UUID.html","title":"JsonRPC.UUID","type":"module"},{"doc":"","ref":"JsonRPC.HandleRequestError.html","title":"JsonRPC.HandleRequestError","type":"exception"}]